// Copyright (C) 2017 James Jonathan Cook
// This program is distributed under the terms of the GNU Lesser General Public License.
//
// This program was written by James Jonathan Cook (jmsck55@gmail.com)
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
//#include <windows.h>

#include "euthread.c"

new_mutex(count_mutex);
new_condition(condition_var);
//CONDITION_VARIABLE x;
//pthread_cond_t  condition_var   = PTHREAD_COND_INITIALIZER;

euthread_function(functionCount1, lp);
euthread_function(functionCount2, lp);
int  count = 0;
#define COUNT_DONE  10
#define COUNT_HALT1  3
#define COUNT_HALT2  6

int main()
{
   pthread_t thread1, thread2;
   int hThread1, hThread2;
   
	init();
	
	initCondition(&condition_var);
	
	// Initialize the critical section one time only.
	initSection(&count_mutex);
   
   
   hThread1 = createThread( &thread1, functionCount1, NULL);
   hThread2 = createThread( &thread2, functionCount2, NULL);

   joinThread( hThread1, NULL);
   joinThread( hThread2, NULL);

	closeHandle((HANDLE)hThread1);
	closeHandle((HANDLE)hThread2);
   
	// Release resources used by the critical section object.
	freeSection(&count_mutex);
	
   printf("Final count: %d\n",count);


FreeLibary(kernel32);

   return 0;
   //exit(EXIT_SUCCESS);
}

// Write numbers 1-3 and 8-10 as permitted by functionCount2()

euthread_function(functionCount1, lp)
{
   for(;;)
   {
      // Lock mutex and then wait for signal to relase mutex
      lockSection( &count_mutex );

      // Wait while functionCount2() operates on count
      // mutex unlocked if condition varialbe in functionCount2() signaled.
      sleepCondition( &condition_var, &count_mutex );
      //SleepConditionVariableCS();
      //pthread_cond_wait( &condition_var, &count_mutex );
      count++;
      printf("Counter value functionCount1: %d\n",count);

      unlockSection( &count_mutex );

      if(count >= COUNT_DONE) return 0; // (NULL)
    }
}

// Write numbers 4-7

euthread_function(functionCount2, lp)
{
    for(;;)
    {
       lockSection( &count_mutex );

       if( count < COUNT_HALT1 || count > COUNT_HALT2 )
       {
          // Condition of if statement has been met. 
          // Signal to free waiting thread by freeing the mutex.
          // Note: functionCount1() is now permitted to modify "count".
          wakeCondition( &condition_var );
          //WakeConditionVariable();
          //pthread_cond_signal( &condition_var );
       }
       else
       {
          count++;
          printf("Counter value functionCount2: %d\n",count);
       }

       unlockSection( &count_mutex );

	if(count >= COUNT_DONE) return 0; // (NULL)
    }

}
