// Copyright (C) 2017 James Jonathan Cook
// This program is distributed under the terms of the GNU Lesser General Public License.
//
// This program was written by James Jonathan Cook (jmsck55@gmail.com)
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
#ifndef euthreadpthread_h__
#define euthreadpthread_h__

#include <stdio.h>
#include <stdlib.h>

#include <time.h>
// use nanosleep()
#include <unistd.h>

#include <pthread.h>
#include <sched.h>

/*
#include <windows.h>
#include <synchapi.h>
*/

// Global variable
#define init(foo)
#define closeHandle(foo)
#define FreeLibrary(foo)
#define euthread_function(NAME, ARG) void * NAME (void * ARG)
#define new_mutex(NAME) pthread_mutex_t NAME = PTHREAD_MUTEX_INITIALIZER
#define new_condition(NAME) pthread_cond_t NAME = PTHREAD_COND_INITIALIZER;
#define initSection(foo)
#define freeSection(foo)
#define initCondition(foo)


#ifdef __cplusplus
extern "C" {
#endif

extern void foo(void);

//extern

extern int createThread(pthread_t * thread, void *(*start_routine) (void *), void * arg);
extern int joinThread(int thread, void * retval);
extern int yieldThread(void);
extern void exitThread(void * retval);
extern int selfThread(void);
//#define initSection(foo)
//#define freeSection(foo)
extern void lockSection(pthread_mutex_t *);
extern void unlockSection(pthread_mutex_t *);
//#define initCondition(foo)
extern int sleepCondition(pthread_cond_t *restrict cond, pthread_mutex_t *restrict mutex);
extern int wakeCondition(pthread_cond_t *cond);


#ifdef __cplusplus
}
#endif

#endif // euthreadpthread_h__
