// Copyright (C) 2017 James Jonathan Cook
// This program is distributed under the terms of the GNU Lesser General Public License.
//
// This program was written by James Jonathan Cook (jmsck55@gmail.com)
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU Lesser General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU Lesser General Public License for more details.
//
//    You should have received a copy of the GNU Lesser General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//

// !!PSUEDO CODE: (PRE-PROCESSOR ANNOTATIONS)

#include <stdio.h>
#include <stdlib.h>

#include "euthreadwin.c"

//#define euthread_function(NAME, ARG) DWORD WINAPI NAME( LPVOID ARG )

euthread_function(MyThreadFunction, lpParameter);

// Global variable
CRITICAL_SECTION CriticalSection;
int counter = 0;

int main()
{
	pthread_t ThreadId1, ThreadId2;
	int hThread1, hThread2;
	foo();
	init();
	// Initialize the critical section one time only.
	initSection(&CriticalSection);

printf("Compiled OK.\n");
   /* Create independent threads each of which will execute functionC */

	hThread1 = createThread(&ThreadId1, MyThreadFunction, NULL);
	if(hThread1 < 0)
	{
		printf("Thread creation failed: 1\n");
		ExitProcess(2);
	}
	hThread2 = createThread(&ThreadId2, MyThreadFunction, NULL);
	if(hThread2 < 0)
	{
		printf("Thread creation failed: 2\n");
		ExitProcess(2);
	}

   /* Wait till threads are complete before main continues. Unless we  */
   /* wait we run the risk of executing an exit which will terminate   */
   /* the process and all threads before the threads have completed.   */

//See also: "MsgWaitForMultipleObjectsEx"
	joinThread(hThread1, NULL);
	joinThread(hThread2, NULL);
	
	closeHandle((HANDLE)hThread1);
	closeHandle((HANDLE)hThread2);
	
	// Release resources used by the critical section object.
	freeSection(&CriticalSection);

FreeLibary(kernel32);

printf("SUCCESS!\n");
getc(stdin);
   return EXIT_SUCCESS;
}

euthread_function(MyThreadFunction, lpParameter)
//DWORD WINAPI MyThreadFunction( LPVOID lpParameter )
{
    // Request ownership of the critical section.
    lockSection(&CriticalSection); 
   counter++;
   printf("Counter value: %d\n",counter);
    // Release ownership of the critical section.
    unlockSection(&CriticalSection);
return 0;
}
